
;--------------------------------------------------------------------------------

INCVALUE MACRO iPos:REQ, iLastDigit:VARARG
    mov al, [esi+iPos]

    .if ( al == "9" )
        mov al, "0"
        mov [esi+iPos], al
        IF iPos EQ 0 ; if 1st digit is incremented need to reset digit 4
            mov al, "0"
            mov [esi+iLastDigit], al            
        ENDIF     
     
    .elseif ( al >= "0") && ( al < "9") ; only increment
        inc al
        mov [esi+iPos], al
    .endif
            
ENDM

READINCWRITEVALUE MACRO lpKey:REQ, lpDefault:REQ
    invoke GetPrivateProfileString, ADDR szVerInf, lpKey, lpDefault, ADDR szBuf, sizeof szBuf, [ebx].lpProject
    .if ( eax ) ; got some characters
        invoke incversion, ADDR szBuf
        mov bUpdateVersion, eax
        invoke WritePrivateProfileString, ADDR szVerInf, lpKey, ADDR szBuf, [ebx].lpProject
    .else
        ; write default
        invoke WritePrivateProfileString, ADDR szVerInf, lpKey, lpDefault, [ebx].lpProject        
        mov bUpdateVersion, FALSE
    .endif
ENDM       

;--------------------------------------------------------------------------------

ADDINOPT struct
	lpStr			dd ?
	nAnd			dd ?
	nOr				dd ?
ADDINOPT ends

;HOOK flags returned in hook1 of HOOK structure
HOOK_ADDINSLOADED				equ 00000001h
HOOK_COMMAND					equ 00000002h
HOOK_CLOSE						equ 00000004h
HOOK_DESTROY					equ 00000008h
HOOK_MENUUPDATE					equ 00000010h
HOOK_FILEOPEN					equ 00000020h
HOOK_FILEOPENED					equ 00000040h
HOOK_FILECLOSE					equ 00000080h
HOOK_FILECLOSED					equ 00000100h
HOOK_FILESAVE					equ 00000200h
HOOK_FILESAVEAS					equ 00000300h
HOOK_FILESAVED					equ 00000800h
HOOK_GETMODIFY					equ 00001000h
HOOK_MAKEBEGIN					equ 00002000h
HOOK_MAKEDONE					equ 00004000h
HOOK_GETFILETYPE				equ 00008000h
HOOK_FILENAMECHANGED			equ 00010000h
HOOK_MENUENABLE					equ 00020000h
HOOK_RASELCHANGE				equ 00040000h
HOOK_MDIACTIVATE				equ 00080000h
HOOK_PARSEFILE					equ 00100000h
HOOK_OUTPUTDBLCLK				equ 00200000h
HOOK_PROJECTCLOSE				equ 00400000h
HOOK_PROJECTCLOSED				equ 00800000h
HOOK_PROJECTOPEN				equ 01000000h
HOOK_PROJECTOPENED				equ 02000000h
HOOK_CODECOMPLETESHOW			equ 04000000h
HOOK_ACTIVATE					equ 08000000h

HOOK struct
	hook1				DWORD ?							;Combinations of HOOK_ flags
	hook2				DWORD ?							;Not used must be zero
	hook3				DWORD ?							;Not used must be zero
	hook4				DWORD ?							;Not used must be zero
HOOK ends
;Messages sendt to addins
AIM_MENUUPDATE					equ WM_USER+104			;RadASM has updated its menues. Now is the time to add menu items. Always return FALSE. hWin=Main window, wParam=hMnu, lParam=hContextMnu. NOTE: This command can be sendt more than once. Do not allocate MenuID's here
;RadASM.mnu
IDM_TOOLS						equ 10043
.data

tempDATE                TEXTEQU @Date
tempTIME                TEXTEQU @Time

tmpd                    CATSTR @SubStr(%tempDATE,4,3),@SubStr(%tempDATE,0,3),<20>,@SubStr(%tempDATE,7,2)
DateText                CATSTR <">, tmpd, <">
TimeText                CATSTR <">, tempTIME, <">

szVersionInc            db "Version-Inc", 0
szError                 db "This RadASM Addin Requires Version 1.2.1.6 Or Higher", 0
szOptions               db "Options", 0
szAbout                 db "Code by X05.", 13, 10, "email: X05_44960@hotmail.com", 13, 10, 13, 10
                        db "Version-Inc v1.1 (rev2)", 13, 10
                        db "Compiled: ", DateText, " ", TimeText, 0
szVerInf                db "VerInf", 0
szFV                    db "FV", 0
szFileVersion           db "FileVersion", 0
szPV                    db "PV", 0
szProductVersion        db "ProductVersion", 0
szDefaultFVPV           db "1.0.0.0", 0
szDefault               db "1.0.0", 0
szEnabled               db "Enabled", 0
szWarningX              db 13, 10, "Unrecognised version format. Example: 1.0.0.0", 13, 10, "String possibly in other format. You need to manually reset it", 13, 10, 0
szWarningXXXX           db 13, 10, "Unrecognised version format. Example: 1.0.0.5000", 13, 10, "String incorrect size", 13, 10, 0
szIniDefault            db "52", 0 ; disabled, xxxx, file+product, warning
szClose                 db "Close", 0

AddinOpt				ADDINOPT <offset szVersionInc,1,1>
						ADDINOPT <0,0,0>
szMenuName		db "VersionControl",0 ; or make the name Version-Inc
;--------------------------------------------------------------------------------

.data?

hInstance               dd ?	; Dll's module handle
hWnd                    dd ?    ; handle to radasm
lpHStruct               dd ?	; Pointer to handles struct
lpPStruct               dd ?	; Pointer to proc struct
lpDStruct               dd ?	; Pointer to data struct
IDVersionInc            dd ?    ; id for menu
iLoadOptions            dd ?    ; load options, 0=disabled, 1 for fileversion only, 2 for file+product version
bError                  dd ?    ; error during increment?
.data?
lpHandles			dd ?	;Pointer to handles struct
lpProc				dd ?	;Pointer to proc struct
lpData				dd ?	;Pointer to data struct
IDAddIn				dd ?	;Unique ID for this AddIn
hook				HOOK <>

;--------------------------------------------------------------------------------
